//Downloaded from hausautomatisierer.de

#define DEBUG
#ifdef DEBUG
  #define DEBUG_PRINT(x)     Serial.print (x)
  #define DEBUG_PRINTDEC(x)  Serial.print (x, DEC)
  #define DEBUG_PRINTLN(x)   Serial.println (x)
#else
  #define DEBUG_PRINT(x)
  #define DEBUG_PRINTDEC(x)
  #define DEBUG_PRINTLN(x) 
#endif 


// HM-MOD-Re-8 HomeMatic 8-Kanal-Empfangsmodul 
// http://www.elv.de/homematic-8-kanal-empfangsmodul.html
const int OUT1pin = 2; //first OUT pin, others following 
const int channelCount = 8;
int channelStates[channelCount] = {-1, -1, -1, -1, -1, -1, -1, -1}; // invalid value (neither HIGH nor LOW), will force full update on startup


// operate remote radio controlled devices with 433MHz AM transmitter
// http://code.google.com/p/rc-switch
#include <RCSwitch.h>
RCSwitch rfModule = RCSwitch();
const int rfModulePin = 13;
char group[2] = "1";
char sockets[4][25]={
//Channels 1-4 OFF-States
 "000000000101010001010100",
 "000000010001010001010100",
 "000000010101000001010100",
 "000000010100010001010100"
};

//temporary variable
int newState;


void setup() {
  #ifdef DEBUG
  Serial.begin(9600);
  #endif
  
  for (int pin=OUT1pin; pin < OUT1pin + channelCount; pin++){
    pinMode(pin, INPUT_PULLUP);
  }
  
  rfModule.enableTransmit(rfModulePin);
}


void loop() {
  for (int i=0; i < channelCount; i++){
    newState = !digitalRead(OUT1pin + i);
    if (newState != channelStates[i]) {
      channelStates[i] = newState;
      
      DEBUG_PRINT("Homematic Channel "); DEBUG_PRINT(i + 1);
      DEBUG_PRINT(" new State "); DEBUG_PRINT(newState);
      DEBUG_PRINT(" -> "); DEBUG_PRINT(sockets[i]);
      
      if (newState == HIGH) {
        //set last Bit to 1
        sockets[i][23]='1';
        //send whole Bit-Structure with fixed length 24 Bit
        rfModule.send(sockets[i]);
        DEBUG_PRINT(" switchOn");
      } else {
        //set last Bit to 0
        sockets[i][23]='0';
        //send whole Bit-Structure with fixed length 24 Bit
        rfModule.send(sockets[i]);
        DEBUG_PRINT(" switchOff");
      }
      DEBUG_PRINT("\n");
    }
  }
}
